/********************************************************

	Audio decoder interface
	Copyright 2000 Eugene Smith (divx@euro.ru)
	Last modified: 19.07.2000

*********************************************************/

#include <audiodecoder_impl.h>
//#pragma pack(2)
class AudioDecoder
{
    AudioDecoder_impl* decoder;
    WAVEFORMATEX in_fmt;
    int m_status;
public:
    AudioDecoder();
    ~AudioDecoder()
    {
	if(decoder)delete decoder;
    }
    int Init(WAVEFORMATEX* format, void* extension);
    int GetOutputFormat(WAVEFORMATEX* destfmt);
    int Convert(unsigned char* in_data, unsigned in_size,
	     unsigned char* out_data, unsigned out_size,
	    unsigned* size_read, unsigned* size_written);
    int Close();
};
  	      