/********************************************************

	Declaration of internal audio class
	Copyright 2000 Eugene Smith (divx@euro.ru)
	Last modified: 16.07.2000

*********************************************************/


#ifndef AUDIODEC_IMPL
#define AUDIODEC_IMPL

#ifndef _WAVEFORMATEX_
#define _WAVEFORMATEX_
typedef struct _WAVEFORMATEX {
  short   wFormatTag;
  short   nChannels;
  long  nSamplesPerSec;
  long  nAvgBytesPerSec;
  short   nBlockAlign;
  short   wBitsPerSample;
  short   cbSize;
} WAVEFORMATEX, *PWAVEFORMATEX, *NPWAVEFORMATEX, *LPWAVEFORMATEX;
#endif

class AudioDecoder_impl
{
public:
    virtual int Init(WAVEFORMATEX*  format, void* extension) =0;
    virtual int Convert(unsigned char* in_data, unsigned in_size,
	     unsigned char* out_data, unsigned out_size,
	    unsigned* size_read, unsigned* size_written) =0;
    virtual int Close() =0;
};    	      
#endif